using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace testXNA
{
	/// <summary>
	/// This is the main type for your game
	/// </summary>
	public class Game1 : Microsoft.Xna.Framework.Game
	{
		GraphicsDeviceManager graphics;
		SpriteBatch spriteBatch;
		private Texture2D zozor;
		private Vector2 zozorPos, zozorMov;
		private SpriteFont font;
		private KeyboardState keyboardState;
		private int frames;
		private bool unraiseFPS;

		public Game1()
		{
			this.unraiseFPS = false;
			graphics = new GraphicsDeviceManager(this);
			Content.RootDirectory = "Content";
			if (this.unraiseFPS)
			{
				IsFixedTimeStep = false;
				graphics.SynchronizeWithVerticalRetrace = false;
			}
		}

		/// <summary>
		/// Allows the game to perform any initialization it needs to before starting to run.
		/// This is where it can query for any required services and load any non-graphic
		/// related content.  Calling base.Initialize will enumerate through any components
		/// and initialize them as well.
		/// </summary>
		protected override void Initialize()
		{
			zozorPos = Vector2.Zero;
			zozorMov = new Vector2(5);
			frames = 0;

			base.Initialize();
		}

		/// <summary>
		/// LoadContent will be called once per game and is the place to load
		/// all of your content.
		/// </summary>
		protected override void LoadContent()
		{
			// Create a new SpriteBatch, which can be used to draw textures.
			spriteBatch = new SpriteBatch(GraphicsDevice);

			zozor = Content.Load<Texture2D>("zozor");
			font = Content.Load<SpriteFont>("test");
		}

		/// <summary>
		/// UnloadContent will be called once per game and is the place to unload
		/// all content.
		/// </summary>
		protected override void UnloadContent()
		{
			// TODO: Unload any non ContentManager content here
		}

		/// <summary>
		/// Allows the game to run logic such as updating the world,
		/// checking for collisions, gathering input, and playing audio.
		/// </summary>
		/// <param name="gameTime">Provides a snapshot of timing values.</param>
		protected override void Update(GameTime gameTime)
		{
			// Allows the game to exit
			if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
				this.Exit();

			if (zozorPos.Y + zozor.Height >= Window.ClientBounds.Height)
				zozorMov.Y = -2;
			else if (zozorPos.X + zozor.Width >= Window.ClientBounds.Width)
				zozorMov.X = -2;
			else if (zozorPos.Y < 0)
				zozorMov.Y = 2;
			else if (zozorPos.X < 0)
				zozorMov.X = 2;
			zozorPos += zozorMov;
			keyboardState = Keyboard.GetState();
			if (keyboardState.IsKeyDown(Keys.Up))
				zozorPos.Y -= 5;
			else if (keyboardState.IsKeyDown(Keys.Down))
				zozorPos.Y += 5;
			if (keyboardState.IsKeyDown(Keys.Right))
				zozorPos.X += 5;
			else if (keyboardState.IsKeyDown(Keys.Left))
				zozorPos.X -= 5;
			frames++;

			base.Update(gameTime);
		}

		/// <summary>
		/// This is called when the game should draw itself.
		/// </summary>
		/// <param name="gameTime">Provides a snapshot of timing values.</param>
		protected override void Draw(GameTime gameTime)
		{
			GraphicsDevice.Clear(Color.CornflowerBlue);

			spriteBatch.Begin();
			spriteBatch.DrawString(font, this.frames.ToString(), new Vector2(10, 20), Color.White);
			spriteBatch.Draw(this.zozor, this.zozorPos, Color.White);
			spriteBatch.End();

			base.Draw(gameTime);
		}
	}
}
